# -*- coding: utf-8 -*-

"""
Calcul et affichage de la trajectoire d'une bille de billard lancé
dans un billard de forme polygonale convexe
@author: Loïc Devilliers
"""

#Polygone(3)
#A=(0.5,0)
#t=1/4

##Importation des bibliothèques dont modulegeometrie codée pour l'occasion
import matplotlib.pyplot as plt#Bibliothèque Pyton qui gère l'affichage
from modulegeometrie import *

##Définition des bords du billard et conditions initiales
N=50  #Nombre de rebonds
Sommets=Polygone(21,2)#Polygone(n) renvoie un polygone à n côtés réguliers
#sous forme des coordonnées des n sommets
#Polygone(n,t) renvoie un polygone à n côté non réguliers étiré du paramètre t
p=len(Sommets)
Cotes=[[Sommets[k],Sommets[(k+1)%p]] for k in range(p)]
#Cotes[k] le k-ième cote du polygone
Droites=[DroiteProlongeSegment(Cotes[k]) for k in range(p)]
#Droites[k] est la droite prolongeant Cotes[k]

A=(0.5,0)#Premier point, peut être n'importe où dans le billard,
#A[0] son abscisse, A[1] son ordonnée
NSB=0#Numéro du Segment où est B
t=1/4#Coefficient de la combinaison convexe pour définir B dans Cotes[c]
B=(t*Cotes[NSB][0][0]+(1-t)*Cotes[NSB][1][0], \
t*Cotes[NSB][0][1]+(1-t)*Cotes[NSB][1][1])

assert EtreDansSegment(Cotes[NSB],B), "Le segment de B est mal renseigné"

##Affichage du billard
plt.plot([Sommets[k][0] for k in range(-1,p)],\
[Sommets[k][1] for k in range(-1,p)],'b')
plt.axis('equal')#Les échelles en x et y sont les mêmes
plt.pause (0.5)

##Calcul et affichage du i-ème rebond, i entre 0 et N-1
for i in range(N):
    plt.plot([A[0],B[0]], [A[1],B[1]],'r')  # Affichage du segment [A,B],
    plt.xlabel(str(i+2))                    # Affichage du nombre de points
    plt.pause(0.1)
    D1=DroiteProlongeSegment([A,B])#Équation de la droite (A,B)
    Delta=SymetriqueDUneDroiteParRapportAUneDroite(D1,Droites[NSB])#Delta est
    #la droite symétrique de (A,B) par rapport au coté du billard où est B
    Inter=False
    k=0#k: indice du segment avec lequel on va intersecter Delta
    while Inter is False and k<p:
        D=Droites[k]#pour chaque droite prolongeant l'un des segment du billard,
        P=IntersectionDeuxDroites(Droites[k],Delta)#on calcule l'intersection
        #avec Delta
        if P is not None and EtreDansSegment(Cotes[k],P) and k!=NSB:
            #Test si P existe bien (cas des droites non parallèles)
            #et si il est dans le segment k et si B n'est pas dans ce segment
            A=B#Mise à jour de A
            B=P# Mise à jour de B
            NSB=k#Mise à jour du numéro du segemnt où est B
            Inter=True#On a bien trouvé une intersection entre Delta et
            #l'un des segment du billard la boucle while va s'arrêter
        k=k+1
    assert Inter, "Aucune Intersection de trouvée"
