# -*- coding: utf-8 -*-

"""
Calcul et affichage de deux trajectoires de billard avec des conditions
initiales très proches
@author: Loïc Devilliers
"""

from matplotlib.pyplot import *#Paquet qui gère affichage
import numpy as np

L=4         #demi-longueur du côté horizontal
l=1      #demi-longueur du côté vertical

A=[0,-l]  #Premier point de la trajectoire 1
B=[L,0.4]     #Deuxième point de la trajectoire 1

Ap=[0,-l]  #Premier point de la trajectoire 2
Bp=[L,0.401]     #Deuxième point de la trajectoire 2
N=1000
     #Nombre de rebonds
subplot(2,1,1)
plot([L,L,-L,-L,L],[l,-l,-l,l,l],'b')#Affiche le billard
axis('equal')#Les échelles en x et y sont les mêmes
title("Trajectoire périodique")
pause(0.5)

subplot(2,1,2)
plot([L,L,-L,-L,L],[l,-l,-l,l,l],'b')#Affiche le billard
axis('equal')#Les échelles en x et y sont les mêmes
title("Perturbation de la condition initiale par rapport à la première\
trajectoire")

for k in range(N-1):#À chaque k: calcul du rebond suivant
    subplot(2,1,1)
    plot([A[0],B[0]], [A[1],B[1]],'r')#Affiche [A,B]
    pause(0.1) # Pause pour voir la trajectoire défiler

    subplot(2,1,2)
    plot([Ap[0],Bp[0]], [Ap[1],Bp[1]],'r')#Affiche [A,B]
    pause(0.1) # Pause pour voir la trajectoire défiler

    D=[L,B[1]-(B[1]-A[1])/(B[0]-A[0])*(L-B[0])]
    E=[-L,B[1]-(B[1]-A[1])/(B[0]-A[0])*(-L-B[0])]
    F=[B[0]-(B[0]-A[0])/(B[1]-A[1])*(l-B[1]),l]
    G=[B[0]-(B[0]-A[0])/(B[1]-A[1])*(-l-B[1]),-l]

    A=B    #Avant dernier point de la trajectoire
    if D!=A and abs(D[1])<l:#Test si D est dans le segment
        B=D  #B est alors le point du rebond suivant
    if E!=A and abs(E[1])<l:#Test si E est dans le segment
        B=E  #B est alors le point du rebond suivant
    if F!=A and abs(F[0])<L:#Test si F est dans le segment
        B=F #B est alors le point du rebond suivant
    if G!=A and abs(G[0])<L:#Test si G est dans le segment
        B=G #B est alors le point du rebond suivant

    Dp=[L,Bp[1]-(Bp[1]-Ap[1])/(Bp[0]-Ap[0])*(L-Bp[0])]
    Ep=[-L,Bp[1]-(Bp[1]-Ap[1])/(Bp[0]-Ap[0])*(-L-Bp[0])]
    Fp=[Bp[0]-(Bp[0]-Ap[0])/(Bp[1]-Ap[1])*(l-Bp[1]),l]
    Gp=[Bp[0]-(Bp[0]-Ap[0])/(Bp[1]-Ap[1])*(-l-Bp[1]),-l]

    Ap=Bp    #Avant dernier point de la trajectoire
    if Dp!=Ap and abs(Dp[1])<l:#Test si D est dans le segment
        Bp=Dp  #B est alors le point du rebond suivant
    if Ep!=Ap and abs(Ep[1])<l:#Test si E est dans le segment
        Bp=Ep  #B est alors le point du rebond suivant
    if Fp!=Ap and abs(Fp[0])<L:#Test si F est dans le segment
        Bp=Fp #B est alors le point du rebond suivant
    if Gp!=Ap and abs(Gp[0])<L:#Test si G est dans le segment
        Bp=Gp #B est alors le point du rebond suivant