# -*- coding: utf-8 -*-

"""
Calcul des termes de la suite de Héron avec affichage des rectangles
tendant vers le carré.
"""

import matplotlib.pyplot as plt

##Constantes à fixer par l'utilisateur
a=50  #Nombre dont on veut approximer la racine carré
N=10    #Nombre de termes calculés dans la suite
m=0     #Indice du premier terme affiché
u=a    #U_0: Premier terme de la suite de Héron

##Cœur du programme
v=a/u   #V_0: premier terme de la seconde suite de Héron
U=[]#U_i: longueur du rectangle numéro i
V=[]#V_i: hauteur du rectangle numéro i (ce rectangle est d'aire a)

for i in range(N):
    U.append(u)#u=U_i
    V.append(v)#v=V_i
    u=(u+v)/2#On moyenne la longueur et la largeur du rectangle, u=U_{i+1}
    v=a/u# On adapte v pour garder une aire constante, v=V_{i+1}

##Résultat et affichage
plt.figure(1)
plt.plot(range(m,N),U[m:],'bo')#Affichage des nombres U_m, U_{m+1},..., U_{N-1}
plt.plot(range(m,N),V[m:],'ro')#Affichage des nombres V_m, V_{m+1},..., V_{N-1}
plt.title("Graphe des deux suites de Héron encadrant la racine carrée")
#plt.legend("UV")
plt.legend(["Suite U","Suite V"])
plt.show()

print("Une approximation de racine de",a,"est", U[-1],
"avec une erreur inferieure à", abs(U[-1]-V[-1]))

plt.figure(2)
plt.axis('equal')
plt.axis([-1,U[m]*1.05,-1,V[N-1]*1.1])
plt.title('Affichage des différents rectangles de même aire'\
'\n donnée tendant vers le carré')

for i in range(m,N):#Affichage des rectangles
    plt.plot([0,0,U[i],U[i],0],[0,V[i],V[i],0,0])
    plt.pause(1)